Index: trunk/kernel/kern/rpc.c
===================================================================
--- trunk/kernel/kern/rpc.c	(revision 690)
+++ trunk/kernel/kern/rpc.c	(revision 1)
@@ -2504,360 +770,743 @@
     rpc.args[1] = (uint64_t)vaddr;
 
-    // register RPC request in remote RPC fifo
-    rpc_send( cxy , &rpc );
+    // register RPC request in remote RPC fifo (blocking function)
+    rpc_send_sync( cxy , &rpc );
 
     // get output argument from rpc descriptor
     *vseg_xp = rpc.args[2];
-    *error   = (error_t)rpc.args[3];
-
-#if DEBUG_RPC_VMM_GET_VSEG
-cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_VMM_GET_VSEG )
-printk("\n[%s] thread[%x,%x] on core %d exit / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid , cycle );
-#endif
-}
-
-/////////////////////////////////////////
-void rpc_vmm_get_vseg_server( xptr_t xp )
-{
-#if DEBUG_RPC_VMM_GET_VSEG
-thread_t * this = CURRENT_THREAD;
-uint32_t cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_VMM_GET_VSEG )
-printk("\n[%s] thread[%x,%x] on core %d enter / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid , cycle );
-#endif
-
+}
+
+/////////////////////////////////////////////
+void rpc_vmm_get_ref_vseg_server( xptr_t xp )
+{
     process_t   * process;
     intptr_t      vaddr;
     vseg_t      * vseg_ptr;
     xptr_t        vseg_xp;
-    error_t       error;
-
-    // get client cluster identifier and pointer on RPC descriptor
-    cxy_t        client_cxy  = GET_CXY( xp );
-    rpc_desc_t * desc        = GET_PTR( xp );
+
+    // get client cluster identifier and pointer on RPC descriptor
+    cxy_t        client_cxy  = (cxy_t)GET_CXY( xp );
+    rpc_desc_t * desc        = (rpc_desc_t *)GET_PTR( xp );
 
     // get input argument from client RPC descriptor
-    process = (process_t *)(intptr_t)hal_remote_l64( XPTR( client_cxy , &desc->args[0] ) );
-    vaddr   = (intptr_t)hal_remote_l64( XPTR( client_cxy , &desc->args[1] ) );
+    process = (process_t *)(intptr_t)hal_remote_lwd( XPTR( client_cxy , &desc->args[0] ) );
+    vaddr   = (intptr_t)hal_remote_lwd( XPTR( client_cxy , &desc->args[1] ) );
     
     // call local kernel function
-    error = vmm_get_vseg( process , vaddr , &vseg_ptr );
-
-    // set output arguments to client RPC descriptor
+    vseg_ptr = vmm_get_vseg( process , vaddr );
+
+    // set output argument to client RPC descriptor
     vseg_xp = XPTR( local_cxy , vseg_ptr );
-    hal_remote_s64( XPTR( client_cxy , &desc->args[2] ) , (uint64_t)vseg_xp );
-    hal_remote_s64( XPTR( client_cxy , &desc->args[3] ) , (uint64_t)error );
-
-#if DEBUG_RPC_VMM_GET_VSEG
-cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_VMM_GET_VSEG )
-printk("\n[%s] thread[%x,%x] on core %d exit / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid , cycle );
-#endif
-}
-
-/////////////////////////////////////////////////////////////////////////////////////////
-// [22]          RPC_KCM_ALLOC deprecated [AG] sept 2019
-/////////////////////////////////////////////////////////////////////////////////////////
-void rpc_kcm_alloc_client( cxy_t      cxy,
-                           uint32_t   kmem_type,   // in
-                           xptr_t   * buf_xp )     // out
-{
-#if DEBUG_RPC_KCM_ALLOC
-thread_t * this = CURRENT_THREAD;
-uint32_t cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_KCM_ALLOC )
-printk("\n[%s] thread[%x,%x] on core %d enter / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid , cycle );
-#endif
-
-    uint32_t responses = 1;
-
-    // initialise RPC descriptor header 
-    rpc_desc_t  rpc;
-    rpc.index    = RPC_KCM_ALLOC;
-    rpc.blocking = true;
-    rpc.rsp      = &responses;
+    hal_remote_swd( XPTR( client_cxy , &desc->args[2] ) , (uint64_t)vseg_xp );
+}
+
+
+/////////////////////////////////////////////////////////////////////////////////////////
+//               Marshaling functions attached to RPC_VMM_GET_PTE 
+/////////////////////////////////////////////////////////////////////////////////////////
+
+////////////////////////////////////////////
+void rpc_vmm_get_pte_client( cxy_t       cxy,   
+                             process_t * process,  // in 
+                             vpn_t       vpn,      // in 
+                             uint32_t  * attr,     // out
+                             ppn_t     * ppn,      // out
+                             error_t   * error )   // out 
+{
+    // RPC must be remote
+    if( cxy == local_cxy ) 
+    {
+        printk("PANIC in %s : target is not remote\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
+
+    // initialise RPC descriptor header 
+    rpc_desc_t  rpc;
+    rpc.index    = RPC_VMM_GET_PTE;
+    rpc.response = 1;
 
     // set input arguments in RPC descriptor 
-    rpc.args[0] = (uint64_t)kmem_type;
-
-    // register RPC request in remote RPC fifo
-    rpc_send( cxy , &rpc );
+    rpc.args[0] = (uint64_t)(intptr_t)process;
+    rpc.args[1] = (uint64_t)vpn;
+
+    // register RPC request in remote RPC fifo (blocking function)
+    rpc_send_sync( cxy , &rpc );
+
+    // get output argument from rpc descriptor
+    *attr  = (uint32_t)rpc.args[2];
+    *ppn   = (ppn_t)rpc.args[3];
+    *error = (error_t)rpc.args[4];
+}
+
+////////////////////////////////////////
+void rpc_vmm_get_pte_server( xptr_t xp )
+{
+    process_t   * process;
+    vpn_t         vpn;
+    uint32_t      attr;
+    ppn_t         ppn;
+    error_t       error;
+
+    // get client cluster identifier and pointer on RPC descriptor
+    cxy_t        client_cxy  = (cxy_t)GET_CXY( xp );
+    rpc_desc_t * desc        = (rpc_desc_t *)GET_PTR( xp );
+
+    // get input argument "process" & "vpn" from client RPC descriptor
+    process = (process_t *)(intptr_t)hal_remote_lwd( XPTR( client_cxy , &desc->args[0] ) );
+    vpn     = (vpn_t)                hal_remote_lwd( XPTR( client_cxy , &desc->args[1] ) );
+    
+    // call local kernel function
+    error = vmm_get_pte( process , vpn , &attr , &ppn ); 
+
+    // set output argument "attr" & "ppn" to client RPC descriptor
+    hal_remote_swd( XPTR( client_cxy , &desc->args[2] ) , (uint64_t)attr );
+    hal_remote_swd( XPTR( client_cxy , &desc->args[3] ) , (uint64_t)ppn );
+    hal_remote_swd( XPTR( client_cxy , &desc->args[4] ) , (uint64_t)error );
+}
+
+/////////////////////////////////////////////////////////////////////////////////////////
+//               Marshaling functions attached to RPC_SEMAPHORE_ALLOC 
+/////////////////////////////////////////////////////////////////////////////////////////
+
+//////////////////////////////////////////////
+void rpc_semaphore_alloc_client( cxy_t    cxy,
+                                 xptr_t * sem_xp )     // out
+{
+    // RPC must be remote
+    if( cxy == local_cxy ) 
+    {
+        printk("PANIC in %s : target is not remote\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
+
+    // initialise RPC descriptor header 
+    rpc_desc_t  rpc;
+    rpc.index    = RPC_THREAD_USER_CREATE;
+    rpc.response = 1;
+
+    // register RPC request in remote RPC fifo 
+    rpc_send_sync( cxy , &rpc );
 
     // get output arguments from RPC descriptor
-    *buf_xp = (xptr_t)rpc.args[1];
-
-#if DEBUG_RPC_KCM_ALLOC
-cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_KCM_ALLOC )
-printk("\n[%s] thread[%x,%x] on core %d exit / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid , cycle );
-#endif
-}
-
-//////////////////////////////////////
-void rpc_kcm_alloc_server( xptr_t xp )
-{
-#if DEBUG_RPC_KCM_ALLOC
-thread_t * this = CURRENT_THREAD;
-uint32_t cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_KCM_ALLOC )
-printk("\n[%s] thread[%x,%x] on core %d enter / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid , cycle );
-#endif
-
-    // get client cluster identifier and pointer on RPC descriptor
-    cxy_t        client_cxy  = GET_CXY( xp );
-    rpc_desc_t * desc        = GET_PTR( xp );
-
-    // get input argument "kmem_type" from client RPC descriptor
-    uint32_t kmem_type = (uint32_t)hal_remote_l64( XPTR( client_cxy , &desc->args[0] ) );
-
-    // allocates memory for kcm
+    *sem_xp = (xptr_t)rpc.args[0];
+}
+
+////////////////////////////////////////////
+void rpc_semaphore_alloc_server( xptr_t xp )
+{
+    // get client cluster identifier and pointer on RPC descriptor
+    cxy_t        client_cxy  = (cxy_t)GET_CXY( xp );
+    rpc_desc_t * desc = (rpc_desc_t *)GET_PTR( xp );
+
+    // allocates memory for semaphore
     kmem_req_t  req;
-    req.type  = kmem_type;
+    req.type  = KMEM_SEM;
     req.flags = AF_ZERO;
-    void * buf_ptr = kmem_alloc( &req );
+    remote_sem_t * sem_ptr = kmem_alloc( &req );
 
     // set output argument
-    xptr_t buf_xp = XPTR( local_cxy , buf_ptr );
-    hal_remote_s64( XPTR( client_cxy , &desc->args[1] ) , (uint64_t)buf_xp );
-
-#if DEBUG_RPC_KCM_ALLOC
-cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_KCM_ALLOC )
-printk("\n[%s] thread[%x,%x] on core %d exit / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid , cycle );
-#endif
+    xptr_t sem_xp = XPTR( local_cxy , sem_ptr );
+    hal_remote_swd( XPTR( client_cxy , &desc->args[0] ) , (uint64_t)sem_xp );
 }   
 
 /////////////////////////////////////////////////////////////////////////////////////////
-// [23]          RPC_KCM_FREE deprecated [AG] sept 2019
-/////////////////////////////////////////////////////////////////////////////////////////
-void rpc_kcm_free_client( cxy_t      cxy,
-                          void     * buf,          // in
-                          uint32_t   kmem_type )   // in
-{
-#if DEBUG_RPC_KCM_FREE
-thread_t * this = CURRENT_THREAD;
-uint32_t cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_KCM_FREE )
-printk("\n[%s] thread[%x,%x] on core %d enter / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid , cycle );
-#endif
-
-    uint32_t responses = 1;
-
-    // initialise RPC descriptor header 
-    rpc_desc_t  rpc;
-    rpc.index    = RPC_KCM_FREE;
-    rpc.blocking = true;
-    rpc.rsp      = &responses;
+//               Marshaling functions attached to RPC_SEMAPHORE_FREE 
+/////////////////////////////////////////////////////////////////////////////////////////
+
+///////////////////////////////////////////////////
+void rpc_semaphore_free_client( cxy_t          cxy,
+                                remote_sem_t * sem )   // in
+{
+    // RPC must be remote
+    if( cxy == local_cxy ) 
+    {
+        printk("PANIC in %s : target is not remote\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
+
+    // initialise RPC descriptor header 
+    rpc_desc_t  rpc;
+    rpc.index    = RPC_THREAD_USER_CREATE;
+    rpc.response = 1;
 
     // set input arguments in RPC descriptor 
-    rpc.args[0] = (uint64_t)(intptr_t)buf;
-    rpc.args[1] = (uint64_t)kmem_type;
-
-    // register RPC request in remote RPC fifo
-    rpc_send( cxy , &rpc );
-
-#if DEBUG_RPC_KCM_FREE
-cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_KCM_FREE )
-printk("\n[%s] thread[%x,%x] on core %d exit / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid , cycle );
-#endif
-}
-
-/////////////////////////////////////
-void rpc_kcm_free_server( xptr_t xp )
-{
-#if DEBUG_RPC_KCM_FREE
-thread_t * this = CURRENT_THREAD;
-uint32_t cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_KCM_FREE )
-printk("\n[%s] thread[%x,%x] on core %d enter / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid , cycle );
-#endif
-
-    // get client cluster identifier and pointer on RPC descriptor
-    cxy_t        client_cxy  = GET_CXY( xp );
-    rpc_desc_t * desc        = GET_PTR( xp );
-
-    // get input arguments "buf" and "kmem_type" from client RPC descriptor
-    void     * buf = (void *)(intptr_t)hal_remote_l64( XPTR( client_cxy , &desc->args[0] ) );
-    uint32_t   kmem_type = (uint32_t)hal_remote_l64( XPTR( client_cxy , &desc->args[1] ) );
+    rpc.args[0] = (uint64_t)(intptr_t)sem;
+
+    // register RPC request in remote RPC fifo 
+    rpc_send_sync( cxy , &rpc );
+}
+
+///////////////////////////////////////////
+void rpc_semaphore_free_server( xptr_t xp )
+{
+    // get client cluster identifier and pointer on RPC descriptor
+    cxy_t        client_cxy  = (cxy_t)GET_CXY( xp );
+    rpc_desc_t * desc = (rpc_desc_t *)GET_PTR( xp );
+
+    // get input argument "sem_ptr" from client RPC descriptor
+    void * sem = (void *)(intptr_t)hal_remote_lwd( XPTR( client_cxy , &desc->args[0] ) );
 
     // releases memory
     kmem_req_t  req;
-    req.type = kmem_type;
-    req.ptr  = buf;
-    kmem_free( &req );
-
-#if DEBUG_RPC_KCM_FREE
-cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_KCM_FREE )
-printk("\n[%s] thread[%x,%x] on core %d exit / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid , cycle );
-#endif
+    req.type = KMEM_SEM;
+    req.ptr  = sem;
+    kmem_free(&req);
 }   
 
 /////////////////////////////////////////////////////////////////////////////////////////
-// [24]          Marshaling functions attached to RPC_MAPPER_SYNC 
-/////////////////////////////////////////////////////////////////////////////////////////
-void rpc_mapper_sync_client( cxy_t             cxy,
-                             struct mapper_s * mapper,
-                             error_t         * error )
-{
-#if DEBUG_RPC_MAPPER_SYNC
-thread_t * this = CURRENT_THREAD;
-uint32_t cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_MAPPER_SYNC )
-printk("\n[%s] thread[%x,%x] on core %d enter / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid , cycle );
-#endif
-
-    uint32_t responses = 1;
-
-    // initialise RPC descriptor header 
-    rpc_desc_t  rpc;
-    rpc.index    = RPC_MAPPER_SYNC;
-    rpc.blocking = true;
-    rpc.rsp      = &responses;
+//               Marshaling functions attached to RPC_MAPPER_MOVE
+/////////////////////////////////////////////////////////////////////////////////////////
+
+//////////////////////////////////////////////
+void rpc_mapper_move_client( cxy_t        cxy,
+                             mapper_t   * mapper,      // in
+                             bool_t       read,        // in
+                             uint32_t     nb_frags,    // in
+                             fragment_t * frags,       // in
+                             error_t    * error )      // out
+{
+    // RPC must be remote
+    if( cxy == local_cxy ) 
+    {
+        printk("PANIC in %s : target is not remote\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
+
+    // initialise RPC descriptor header 
+    rpc_desc_t  rpc;
+    rpc.index    = RPC_MAPPER_MOVE;
+    rpc.response = 1;
 
     // set input arguments in RPC descriptor 
     rpc.args[0] = (uint64_t)(intptr_t)mapper;
-
-    // register RPC request in remote RPC fifo
-    rpc_send( cxy , &rpc );
-
-    // get output values from RPC descriptor
-    *error   = (error_t)rpc.args[1];
-
-#if DEBUG_RPC_MAPPER_SYNC
-cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_MAPPER_SYNC )
-printk("\n[%s] thread[%x,%x] on core %d exit / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid , cycle );
-#endif
+    rpc.args[1] = (uint64_t)read;
+    rpc.args[2] = (uint64_t)nb_frags;
+    rpc.args[3] = (uint64_t)(intptr_t)frags;
+
+    // register RPC request in remote RPC fifo 
+    rpc_send_sync( cxy , &rpc );
+
+    // get output argument from rpc descriptor
+    *error = (error_t)rpc.args[4];
 }
 
 ////////////////////////////////////////
-void rpc_mapper_sync_server( xptr_t xp )
-{
-#if DEBUG_RPC_MAPPER_SYNC
-thread_t * this = CURRENT_THREAD;
-uint32_t cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_MAPPER_SYNC )
-printk("\n[%s] thread[%x,%x] on core %d enter / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid , cycle );
-#endif
-
-    mapper_t * mapper;
+void rpc_mapper_move_server( xptr_t xp )
+{
+    mapper_t    * mapper;
+    bool_t        read;
+    uint32_t      nb;
+    void        * frags;
+    error_t       error;
+
+    // get client cluster identifier and pointer on RPC descriptor
+    cxy_t        client_cxy  = (cxy_t)GET_CXY( xp );
+    rpc_desc_t * desc = (rpc_desc_t *)GET_PTR( xp );
+
+    // get input arguments
+    mapper = (mapper_t*)(intptr_t)hal_remote_lpt( XPTR( client_cxy , &desc->args[0] ) );
+    read   = (bool_t)             hal_remote_lw ( XPTR( client_cxy , &desc->args[1] ) );
+    nb     = (uint32_t)           hal_remote_lw ( XPTR( client_cxy , &desc->args[2] ) );
+    frags  = (void*)(intptr_t)    hal_remote_lpt( XPTR( client_cxy , &desc->args[3] ) );
+
+    // call the mapper_move_fragments() function
+    error = mapper_move_fragments( mapper , read , nb , XPTR( client_cxy , frags ) );
+
+    // set output argument
+    hal_remote_swd( XPTR( client_cxy , &desc->args[4] ) , (uint64_t)error );
+}
+
+/////////////////////////////////////////////////////////////////////////////////////////
+//               Marshaling functions attached to RPC_ICU_WTI_ALLOC 
+/////////////////////////////////////////////////////////////////////////////////////////
+
+//////////////////////////////////////////////
+void rpc_icu_wti_alloc_client( cxy_t      cxy,
+                               uint32_t * wti_id )    // out
+{
+    // RPC must be remote
+    if( cxy == local_cxy ) 
+    {
+        printk("PANIC in %s : target is not remote\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
+
+    // initialise RPC descriptor header 
+    rpc_desc_t  rpc;
+    rpc.index    = RPC_ICU_WTI_ALLOC;
+    rpc.response = 1;
+
+    // register RPC request in remote RPC fifo 
+    rpc_send_sync( cxy , &rpc );
+
+    // get output argument from rpc descriptor
+    *wti_id = (uint32_t)rpc.args[0];
+}
+
+//////////////////////////////////////////
+void rpc_icu_wti_alloc_server( xptr_t xp )
+{
+    uint32_t      wti_id;
+
+    // get client cluster identifier and pointer on RPC descriptor
+    cxy_t        client_cxy  = (cxy_t)GET_CXY( xp );
+    rpc_desc_t * desc = (rpc_desc_t *)GET_PTR( xp );
+
+    // call icu_wti_alloc() function
+    wti_id = dev_icu_wti_alloc();
+
+    // set output argument
+    hal_remote_swd( XPTR( client_cxy , &desc->args[0] ) , (uint64_t)wti_id);
+}
+
+/////////////////////////////////////////////////////////////////////////////////////////
+//               Marshaling functions attached to RPC_DEVICE_ALLOC 
+/////////////////////////////////////////////////////////////////////////////////////////
+
+/////////////////////////////////////////////
+void rpc_device_alloc_client( cxy_t     cxy,
+                              xptr_t  * dev_xp,      // out
+                              error_t * error )      // out
+{
+    // RPC must be remote
+    if( cxy == local_cxy ) 
+    {
+        printk("PANIC in %s : target is not remote\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
+
+    // initialise RPC descriptor header 
+    rpc_desc_t  rpc;
+    rpc.index    = RPC_DEVICE_ALLOC;
+    rpc.response = 1;
+
+    // register RPC request in remote RPC fifo 
+    rpc_send_sync( cxy , &rpc );
+
+    // get output argument from rpc descriptor
+    *dev_xp = (xptr_t)rpc.args[0];
+    *error  = (error_t)rpc.args[1];
+}    
+
+/////////////////////////////////////////
+void rpc_device_alloc_server( xptr_t xp )
+{
+    error_t      error;
+    kmem_req_t   req;
+    device_t   * dev_ptr;  
+    xptr_t       dev_xp;
+
+    // get client cluster identifier and pointer on RPC descriptor
+    cxy_t        client_cxy  = (cxy_t)GET_CXY( xp );
+    rpc_desc_t * desc = (rpc_desc_t *)GET_PTR( xp );
+
+    // allocate memory for a device descriptor
+    req.type   = KMEM_DEVICE;
+    req.flags  = AF_ZERO;
+    dev_ptr    = (device_t *)kmem_alloc( &req );
+
+    // set output arguments
+    error  = ( dev_ptr == NULL );
+    dev_xp = XPTR( local_cxy , dev_ptr );
+    hal_remote_swd( XPTR( client_cxy , &desc->args[0] ) , (uint64_t)dev_xp );
+    hal_remote_swd( XPTR( client_cxy , &desc->args[1] ) , (uint64_t)error );
+}
+
+
+/////////////////////////////////////////////////////////////////////////////////////////
+//               Marshaling functions attached to RPC_FATFS_GET_CLUSTER 
+/////////////////////////////////////////////////////////////////////////////////////////
+
+//////////////////////////////////////////////////
+void rpc_fatfs_get_cluster_client( cxy_t      cxy,
+                                   mapper_t * mapper,    // in
+                                   uint32_t   first,     // in
+                                   uint32_t   page,      // in
+                                   uint32_t * cluster,   // out
+                                   error_t  * error )    // out
+{
+    // RPC must be remote
+    if( cxy == local_cxy ) 
+    {
+        printk("PANIC in %s : target is not remote\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
+
+    // initialise RPC descriptor header 
+    rpc_desc_t  rpc;
+    rpc.index    = RPC_FATFS_GET_CLUSTER;
+    rpc.response = 1;
+
+    // set input arguments in RPC descriptor 
+    rpc.args[0] = (uint64_t)(intptr_t)mapper;
+    rpc.args[1] = (uint64_t)first;
+    rpc.args[2] = (uint64_t)page;
+
+    // register RPC request in remote RPC fifo 
+    rpc_send_sync( cxy , &rpc );
+
+    // get output argument from rpc descriptor
+    *cluster = (uint32_t)rpc.args[3];
+    *error   = (error_t)rpc.args[4];
+}
+
+//////////////////////////////////////////////
+void rpc_fatfs_get_cluster_server( xptr_t xp )
+{
+    mapper_t    * mapper;
+    uint32_t      first;
+    uint32_t      page;
+    uint32_t      cluster;
+    error_t       error;
+
+    // get client cluster identifier and pointer on RPC descriptor
+    cxy_t        client_cxy  = (cxy_t)GET_CXY( xp );
+    rpc_desc_t * desc = (rpc_desc_t *)GET_PTR( xp );
+
+    // get input arguments
+    mapper = (mapper_t*)(intptr_t)hal_remote_lpt( XPTR( client_cxy , &desc->args[0] ) );
+    first  = (uint32_t)           hal_remote_lw ( XPTR( client_cxy , &desc->args[1] ) );
+    page   = (uint32_t)           hal_remote_lw ( XPTR( client_cxy , &desc->args[2] ) );
+
+    // call the kernel function
+    error = fatfs_get_cluster( mapper , first , page , &cluster );
+
+    // set output argument
+    hal_remote_swd( XPTR( client_cxy , &desc->args[3] ) , (uint64_t)cluster );
+    hal_remote_swd( XPTR( client_cxy , &desc->args[4] ) , (uint64_t)error );
+}
+
+/***************************************************************************************/
+/************ Generic functions supporting RPCs : client side **************************/
+/***************************************************************************************/
+
+////////////////////////////////////////////
+void rpc_send_sync( cxy_t        server_cxy, 
+                    rpc_desc_t * rpc )
+{
+	thread_t * this = CURRENT_THREAD;
+    uint32_t   cores;
     error_t    error;
-
-    // get client cluster identifier and pointer on RPC descriptor
-    cxy_t        client_cxy  = GET_CXY( xp );
-    rpc_desc_t * desc        = GET_PTR( xp );
-
-    // get arguments from client RPC descriptor
-    mapper  = (mapper_t *)(intptr_t)hal_remote_l64( XPTR( client_cxy , &desc->args[0] ) );
-
-    // call local kernel function
-    error = mapper_sync( mapper );
-
-    // set output argument to client RPC descriptor
-    hal_remote_s64( XPTR( client_cxy , &desc->args[1] ) , (uint64_t)error );
-
-#if DEBUG_RPC_MAPPER_SYNC
-cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_MAPPER_SYNC )
-printk("\n[%s] thread[%x,%x] on core %d exit / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid , cycle );
-#endif
-}
-
-*/
-
-
-
-/*
+    bool_t     first;
+    reg_t      sr_save;
+
+    // get client CPU and cluster coordinates
+    cxy_t      client_cxy = local_cxy;   
+    lid_t      client_lid = CURRENT_CORE->lid;
+
+    // allocate and initialise an extended pointer on the RPC descriptor
+	xptr_t   xp = XPTR( client_cxy , rpc );
+
+    // get local pointer on rpc_fifo in remote cluster with the 
+    // assumption that addresses are identical in all clusters
+    rpc_fifo_t * rf = &LOCAL_CLUSTER->rpc_fifo;
+
+	// try to post an item in remote fifo
+    // deschedule and retry if remote fifo full
+    do
+    { 
+        error = remote_fifo_put_item( XPTR( server_cxy , &rf->fifo ),
+                                      (void *)&xp,
+                                      sizeof(xptr_t), 
+                                      &first );
+
+	    if ( error ) 
+        {
+            printk("\n[WARNING] %s : core %d in cluster %x cannot post RPC to cluster %x\n",
+                   __FUNCTION__ , client_lid , client_cxy , server_cxy );
+            if( thread_can_yield() ) sched_yield();
+        }
+    }
+    while( error );
+ 
+    rpc_dmsg("\n[INFO] %s on core %d in cluster %x sent RPC %p to cluster %x\n", 
+              __FUNCTION__ , client_lid , client_cxy , rpc , server_cxy );
+	
+    // send IPI if this is the first RPC in remote FIFO
+    // and no CPU is in kernel mode in server cluster.
+    // the selected CPU in server has the same lid as the client CPU.
+	if( first )
+	{
+        // get number of cores in kernel mode in server cluster
+        cores = hal_remote_lw( XPTR( server_cxy , &LOCAL_CLUSTER->cores_in_kernel ) );
+
+		if( cores == 0 ) // no core in kernel mode in server
+		{
+		    dev_icu_send_ipi( server_cxy , client_lid );
+
+		    rpc_dmsg("\n[INFO] %s : core %d in cluster %x send IPI to core %d in cluster %x\n",
+                      __FUNCTION__, client_lid , client_cxy , client_lid , server_cxy );
+        }
+	}
+
+	// activate preemption to allow incoming RPC and avoid deadlock
+	if( this->type == THREAD_RPC ) hal_enable_irq( &sr_save );
+
+    // the sending thread poll the response slot until RPC completed
+	while( 1 )
+    {
+        if( rpc->response == 0 ) break;
+    }
+
+    // restore preemption
+	if( this->type == THREAD_RPC ) hal_restore_irq( sr_save );
+
+}  // end rpc_send_sync()
+
+
+
+/***************************************************************************************/
+/************ Generic functions supporting RPCs : server side **************************/
+/***************************************************************************************/
+
+///////////////////////////////////////////
+void rpc_fifo_init( rpc_fifo_t * rpc_fifo )
+{
+	rpc_fifo->count       = 0;
+	rpc_fifo->owner       = 0;
+	local_fifo_init( &rpc_fifo->fifo );
+}
+
+////////////////////////////////////////////////
+error_t rpc_execute_all( rpc_fifo_t * rpc_fifo )
+{
+	xptr_t         xp;             // extended pointer on RPC descriptor
+	uint32_t       count;          // handled RPC request counter
+	thread_t     * this;           // pointer on this RPC thread
+    core_t       * core;           // pointer on core running this thread
+    rpc_desc_t   * desc;           // pointer on RPC descriptor 
+    uint32_t       index;          // RPC index 
+    uint32_t       expected;       // number of expected responses 
+    cxy_t          client_cxy;     // client cluster identifier
+	error_t        error;
+      
+	this = CURRENT_THREAD; 
+    core = this->core;   
+
+
+    // handle up to CONFIG_RPC_PENDING_MAX requests before exit
+	count = 0;
+	do
+    {
+	    error = local_fifo_get_item( &rpc_fifo->fifo, 
+                                     &xp,
+                                     sizeof(xptr_t) );
+
+		if ( error == 0 )  // One RPC request successfully extracted from RPC_FIFO
+        {
+            rpc_dmsg("\n[INFO] %s : RPC_THREAD %x on core %x in cluster %x handles RPC %d\n"
+				     __FUNCTION__ , this->trdid , core->lid , local_cxy , count );
+
+            // get client cluster identifier and pointer on RPC descriptor
+            client_cxy = (cxy_t)GET_CXY( xp );
+            desc       = (rpc_desc_t *)GET_PTR( xp );
+
+            // get rpc index and expected responses from RPC descriptor
+	        index     = hal_remote_lw( XPTR( client_cxy , &desc->index ) );
+	        expected  = hal_remote_lw( XPTR( client_cxy , &desc->response ) );
+
+            // call the relevant server function
+            rpc_server[index]( xp );
+
+            // increment handled RPC counter
+  	        count++;
+
+            // notify RPC completion as required
+            if( expected == 1 ) hal_remote_sw( XPTR(client_cxy,&desc->response) , 0 );
+            if( expected >  1 ) hal_remote_atomic_add( XPTR(client_cxy,&desc->response) , -1 );
+		}
+	
+		// exit loop in three cases:
+        // - fifo is empty
+        // - look has been released (because descheduling)
+        // - max number of RPCs has been reached
+		if( error || 
+            (rpc_fifo->owner != this->trdid) || 
+            (count > CONFIG_RPC_PENDING_MAX) ) break;
+	}
+    while( 1 )
+
+	rpc_dmsg("\n[INFO] %s running on core %d in cluster %x exit\n"
+              __FUNCTION__ , CURRENT_CORE->lid , local_cxy );
+		
+    // update RPC_FIFO global counter
+	rpc_fifo->count += count;
+
+	return 0;
+}  // end rpc_execute_all()
+
 ////////////////////////////////////////////////////
-void rpc_fbf_display_client( cxy_t        cxy,
-                             xptr_t       window_xp,
-                             uint32_t     cores,
-                             error_t    * error )
-{
-#if DEBUG_RPC_FBF_DISPLAY
-uint32_t  cycle = (uint32_t)hal_get_cycles();
-thread_t * this = CURRENT_THREAD;
-if( DEBUG_RPC_FBF_DISPLAY < cycle )
-printk("\n[%s] thread[%x,%x] on core %d : enter / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
-#endif
-
-    uint32_t    responses = 1;
-    rpc_desc_t  rpc;
-
-    // initialise RPC descriptor header 
-    rpc.index    = RPC_FBF_DISPLAY;
-    rpc.blocking = true;
-    rpc.rsp      = &responses;
-
-    // set input arguments in RPC descriptor 
-    rpc.args[0] = (uint64_t)window_xp;
-    rpc.args[1] = (uint64_t)cores;
-
-    // register RPC request in remote RPC fifo 
-    rpc_send( cxy , &rpc );
-
-    // get output argument from RPC descriptor
-    *error     = (error_t)rpc.args[2];
-
-#if DEBUG_RPC_FBF_DISPLAY
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_RPC_FBF_DISPLAY < cycle )
-printk("\n[%s] thread[%x,%x] on core %d : exit / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
-#endif
-}
-
-////////////////////////////////////////
-void rpc_fbf_display_server( xptr_t xp )
-{
-    // get client cluster identifier and pointer on RPC descriptor
-    cxy_t        client_cxy = GET_CXY( xp );
-    rpc_desc_t * desc       = GET_PTR( xp );
-
-    // get arguments from RPC descriptor
-    xptr_t   window_xp = (xptr_t  )hal_remote_l64( XPTR(client_cxy , &desc->args[0]) );
-    uint32_t ncores    = (uint32_t)hal_remote_l64( XPTR(client_cxy , &desc->args[1]) );
-
-#if DEBUG_RPC_FBF_DISPLAY
-uint32_t cycle = (uint32_t)hal_get_cycles();
-thread_t * this = CURRENT_THREAD;
-if( DEBUG_RPC_FBF_DISPLAY < cycle )
-printk("\n[%s] thread[%x,%x] on core %d : enter / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
-#endif
-
-    // call relevant kernel function 
-    error_t error = dev_fbf_parallel_display( window_xp , ncores );
-
-    // WARNING : for parallel RPCs, the return error argument is shared
-    hal_remote_atomic_or( XPTR( client_cxy , &desc->args[2] ) , error );
-
-#if DEBUG_RPC_FBF_DISPLAY
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_RPC_FBF_DISPLAY < cycle )
-printk("\n[%s] thread[%x,%x] on core %d : exit / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
-#endif
-} 
-*/
-
-
+error_t rpc_activate_thread( rpc_fifo_t * rpc_fifo )
+{
+	core_t      * core;
+	thread_t    * thread;
+	thread_t    * this;
+    scheduler_t * sched;
+	error_t       error;
+    bool_t        found;
+    reg_t         sr_save;
+
+	this   = CURRENT_THREAD;
+    core   = this->core;
+    sched  = &core->scheduler;
+    found  = false;
+
+    // calling thread must be the RPC_FIFO owner
+    if( this->trdid != rpc_fifo->owner )
+    {
+        printk("\n[PANIC] in %s : calling thread is not RPC_FIFO owner\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
+
+    // makes the calling thread not preemptable
+    // during activation / creation of the RPC thread
+	hal_disable_irq( &sr_save );
+
+    // search a free RPC thread (must be in THREAD_BLOCKED_IDLE state)    
+    list_entry_t * iter;
+    LIST_FOREACH( &sched->k_root , iter )
+    {
+        thread = LIST_ELEMENT( iter , thread_t , sched_list );
+        if( (thread->type == THREAD_RPC) && (thread->blocked ==  THREAD_BLOCKED_IDLE ) ) 
+        {
+            found = true;
+            break;
+        }
+    }
+
+    if( found )                    // activate this idle RPC thread      
+    {
+        thread->blocked = 0;
+    }
+    else                           // create a new RPC thread
+    {
+        error = thread_kernel_create( &thread,
+                                      THREAD_RPC, 
+			                          &rpc_thread_func, 
+                                      NULL,
+			                          core->lid );
+	    if( error ) 
+        {
+	        hal_restore_irq( sr_save );
+            printk("\n[ERROR] in %s : no memory for new RPC thread in cluster %x\n",
+                   __FUNCTION__ , local_cxy );
+            return ENOMEM;
+        }
+
+        rpc_dmsg("\n[INFO] %s creates RPC thread %x on core %x in cluster %x at cycle %d\n", 
+		          __FUNCTION__ , thread , core->gid , local_cxy , hal_time_stamp() );
+
+        // update core descriptor counter  
+	    core->rpc_threads++;
+    }
+
+    // update owner in rpc_fifo
+    rpc_fifo->owner = thread->trdid;
+
+    rpc_dmsg ("\n[INFO] %s activates RPC thread %x on core %x in cluster %x at cycle %d\n",
+		      __FUNCTION__ , thread , core->gid , local_cxy , hal_time_stamp() );
+
+    // current thread deschedules / RPC thread start execution 
+	sched_switch_to( thread );
+
+    // restore IRQs for the calling thread 
+	hal_restore_irq( sr_save );
+
+    // return success
+	return 0;
+
+}  // end rpc_activate_thread()
+
+//////////////////
+bool_t rpc_check()
+{
+	thread_t   * this     = CURRENT_THREAD;
+	rpc_fifo_t * rpc_fifo = &LOCAL_CLUSTER->rpc_fifo;
+    error_t      error;
+
+    // do nothing if light lock already taken or FIFO empty  
+	if( (rpc_fifo->owner != 0) || (local_fifo_is_empty( &rpc_fifo->fifo )) )
+    {
+        return false;
+    }
+
+	// The calling thread try to take the light lock,
+    // and activate an RPC thread if success
+    if( hal_atomic_test_set( &rpc_fifo->owner , this->trdid ) )
+	{
+        error = rpc_activate_thread( rpc_fifo );
+
+        if( error )    // cannot activate an RPC_THREAD 
+        {
+            rpc_fifo->owner = 0;
+
+            printk("\n[ERROR] in %s : no memory to create a RPC thread for core %d"
+                   " in cluster %x => do nothing\n",
+                   __FUNCTION__ , CURRENT_CORE->lid , local_cxy );
+        }
+
+        return true;
+    }
+    else  // light lock taken by another thread
+    {
+        return false;
+    }
+} // end __rpc_check()
+
+
+//////////////////////
+void rpc_thread_func()
+{
+    // makes the calling thread not preemptable
+	hal_disable_irq( NULL );
+  
+	thread_t   * this     = CURRENT_THREAD;
+	rpc_fifo_t * rpc_fifo = &LOCAL_CLUSTER->rpc_fifo;
+
+    rpc_dmsg("\n[INFO] RPC thread %x created on core %d in cluster %x at cycle %d\n",
+             this->trdid , this->core->lid , local_cxy , hal_time_stamp() );
+
+    // this infinite loop is not preemptable
+    // the RPC thread deschedule when the RPC_FIFO is empty
+	while(1)
+	{
+        // check fifo ownership (ownership should be given by rpc_activate()
+        if( this->trdid != rpc_fifo->owner )
+        {
+            printk("\n[PANIC] in %s : RPC_THREAD %x not owner of RPC_FIFO in cluster %x\n",
+                   __FUNCTION__ , this->trdid , local_cxy );
+            hal_core_sleep();
+        }
+ 
+        // executes pending RPC(s) 
+        rpc_execute_all( rpc_fifo );
+
+        // release rpc_fifo ownership (can be lost during RPC execution)
+        if( rpc_fifo->owner == this->trdid ) rpc_fifo->owner = 0;
+
+
+        // suicide if too much RPC threads for this core
+		if( this->core->rpc_threads > CONFIG_RPC_THREADS_MAX ) 
+		{
+            rpc_dmsg("\n[INFO] RPC thread %x suicide on core %d in cluster %x at cycle %d\n", 
+		             this->trdid , this->core->lid , local_cxy , hal_time_stamp() );
+
+            // update core descriptor counter
+			this->core->rpc_threads--;
+
+            // suicide
+			thread_exit();
+		}
+
+        // block and deschedule
+        rpc_dmsg("\n[INFO] RPC thread %x deschedule on core %d in cluster %x at cycle %d\n", 
+			      this->trdid , this->core->lid , local_cxy , hal_time_stamp() ); 
+
+		thread_block( this , THREAD_BLOCKED_IDLE );
+        sched_yield();
+
+		rpc_dmsg("\n[INFO] RPC thread %x wake up on core %d in cluster %x at cycle %d\n", 
+			      this->trdid , this->core->lid , local_cxy , hal_time_stamp() );
+	}
+} // end rpc_thread_func()
+
